<?php

	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();

	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights This may slow down server, uncomment this if you requires an extra security
	// PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_trans_list');

	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_TRANSLIST_ID',
					'PARAM_REC_TRANSLIST_REC_TRANS_ID',
					'PARAM_REC_TRANSLIST_CAT_PRODUCT_ID',
					'PARAM_REC_TRANSLIST_CAT_UOM_ID',
					'PARAM_REC_TRANSLIST_COST_BASE_FROM',
					'PARAM_REC_TRANSLIST_COST_BASE_TO',
					'PARAM_REC_TRANSLIST_COST_ACTUAL_FROM',
					'PARAM_REC_TRANSLIST_COST_ACTUAL_TO',
					'PARAM_REC_TRANSLIST_COST_PC_FROM',
					'PARAM_REC_TRANSLIST_COST_PC_TO',
					'PARAM_REC_TRANSLIST_COST_ALLOWANCE_FROM',
					'PARAM_REC_TRANSLIST_COST_ALLOWANCE_TO',
					'PARAM_REC_TRANSLIST_PRICE_NET_FROM',
					'PARAM_REC_TRANSLIST_PRICE_NET_TO',
					'PARAM_REC_TRANSLIST_ING_PRICE_FROM',
					'PARAM_REC_TRANSLIST_ING_PRICE_TO',
					'PARAM_REC_TRANSLIST_ING_NET_CONTENT_FROM',
					'PARAM_REC_TRANSLIST_ING_NET_CONTENT_TO',
					'PARAM_REC_TRANSLIST_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_TRANSLIST_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_TRANSLIST_ID');
			$PARAM_REC_TRANSLIST_REC_TRANS_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_TRANSLIST_REC_TRANS_ID');
			$PARAM_REC_TRANSLIST_CAT_PRODUCT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_TRANSLIST_CAT_PRODUCT_ID');
			$PARAM_REC_TRANSLIST_CAT_UOM_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_TRANSLIST_CAT_UOM_ID');
			$PARAM_REC_TRANSLIST_COST_BASE_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_BASE_FROM');
			$PARAM_REC_TRANSLIST_COST_BASE_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_BASE_TO');
			$PARAM_REC_TRANSLIST_COST_ACTUAL_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_ACTUAL_FROM');
			$PARAM_REC_TRANSLIST_COST_ACTUAL_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_ACTUAL_TO');
			$PARAM_REC_TRANSLIST_COST_PC_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_PC_FROM');
			$PARAM_REC_TRANSLIST_COST_PC_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_PC_TO');
			$PARAM_REC_TRANSLIST_COST_ALLOWANCE_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_ALLOWANCE_FROM');
			$PARAM_REC_TRANSLIST_COST_ALLOWANCE_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_COST_ALLOWANCE_TO');
			$PARAM_REC_TRANSLIST_PRICE_NET_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_PRICE_NET_FROM');
			$PARAM_REC_TRANSLIST_PRICE_NET_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_PRICE_NET_TO');
			$PARAM_REC_TRANSLIST_ING_PRICE_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_ING_PRICE_FROM');
			$PARAM_REC_TRANSLIST_ING_PRICE_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_ING_PRICE_TO');
			$PARAM_REC_TRANSLIST_ING_NET_CONTENT_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_ING_NET_CONTENT_FROM');
			$PARAM_REC_TRANSLIST_ING_NET_CONTENT_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_TRANSLIST_ING_NET_CONTENT_TO');
			$PARAM_REC_TRANSLIST_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_TRANSLIST_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_TRANSLIST_ID', 
						'REC_TRANSLIST_REC_TRANS_ID', 
						'REC_TRANSLIST_CAT_PRODUCT_ID', 
						'REC_TRANSLIST_CAT_UOM_ID', 
						'REC_TRANSLIST_COST_BASE', 
						'REC_TRANSLIST_COST_ACTUAL', 
						'REC_TRANSLIST_COST_PC', 
						'REC_TRANSLIST_COST_ALLOWANCE', 
						'REC_TRANSLIST_PRICE_NET', 
						'REC_TRANSLIST_ING_PRICE', 
						'REC_TRANSLIST_ING_NET_CONTENT', 
						'REC_TRANSLIST_STATUS'
						, 
						'REC_TRANS_ID',		
						'REC_TRANS_CAT_PRODUCT_ID',		
						'REC_TRANS_REFERENCE_CODE',		
						'REC_TRANS_QUANTITY_YIELD',		
						'REC_TRANS_QUANTITY_POST',		
						'REC_TRANS_QUANTITY_ACTUAL',		
						'REC_TRANS_QUANTITY_MIX',		
						'REC_TRANS_COST_PPC',		
						'REC_TRANS_COST_TOTAL',		
						'REC_TRANS_DATE_POST',		
						'REC_TRANS_DATE_COMPLETE',		
						'REC_TRANS_ACC_ACCOUNT_ID_POST',		
						'REC_TRANS_ACC_ACCOUNT_ID_COMPLETE',		
						'REC_TRANS_STATUS',		
						'CAT_PRODUCT_ID',		
						'CAT_PRODUCT_CAT_UOM_ID',		
						'CAT_PRODUCT_BARCODE',		
						'CAT_PRODUCT_ITEMCODE',		
						'CAT_PRODUCT_DESCRIPTION',		
						'CAT_PRODUCT_HAS_RECIPE',		
						'CAT_PRODUCT_ING_PRICE',		
						'CAT_PRODUCT_ING_NET_CONTENT',		
						'CAT_PRODUCT_MIXTURE_QTY',		
						'CAT_PRODUCT_MIXTURE_COST',		
						'CAT_PRODUCT_STATUS',		
						'CAT_PRODUCT_SYSTEM_GENERATED',		
						'CAT_UOM_ID',		
						'CAT_UOM_DESCRIPTION',		
						'CAT_UOM_STATUS',		
						'CAT_UOM_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_TRANS_LIST::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_ID'] = $PARAM_REC_TRANSLIST_ID;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_REC_TRANS_ID'] = $PARAM_REC_TRANSLIST_REC_TRANS_ID;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_CAT_PRODUCT_ID'] = $PARAM_REC_TRANSLIST_CAT_PRODUCT_ID;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_CAT_UOM_ID'] = $PARAM_REC_TRANSLIST_CAT_UOM_ID;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_BASE_FROM'] = $PARAM_REC_TRANSLIST_COST_BASE_FROM;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_BASE_TO'] = $PARAM_REC_TRANSLIST_COST_BASE_TO;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_ACTUAL_FROM'] = $PARAM_REC_TRANSLIST_COST_ACTUAL_FROM;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_ACTUAL_TO'] = $PARAM_REC_TRANSLIST_COST_ACTUAL_TO;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_PC_FROM'] = $PARAM_REC_TRANSLIST_COST_PC_FROM;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_PC_TO'] = $PARAM_REC_TRANSLIST_COST_PC_TO;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_ALLOWANCE_FROM'] = $PARAM_REC_TRANSLIST_COST_ALLOWANCE_FROM;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_COST_ALLOWANCE_TO'] = $PARAM_REC_TRANSLIST_COST_ALLOWANCE_TO;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_PRICE_NET_FROM'] = $PARAM_REC_TRANSLIST_PRICE_NET_FROM;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_PRICE_NET_TO'] = $PARAM_REC_TRANSLIST_PRICE_NET_TO;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_ING_PRICE_FROM'] = $PARAM_REC_TRANSLIST_ING_PRICE_FROM;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_ING_PRICE_TO'] = $PARAM_REC_TRANSLIST_ING_PRICE_TO;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_ING_NET_CONTENT_FROM'] = $PARAM_REC_TRANSLIST_ING_NET_CONTENT_FROM;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_ING_NET_CONTENT_TO'] = $PARAM_REC_TRANSLIST_ING_NET_CONTENT_TO;
			$GET_MAP_ARRAY['PARAM_REC_TRANSLIST_STATUS'] = $PARAM_REC_TRANSLIST_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_TRANS_LIST::CUS_GET_SUM_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>